Vagrant.configure("2") do |config|
    config.ssh.insert_key = false
    config.vm.synced_folder ".", "/vagrant"
   
    IMAGEN = "geerlingguy/ubuntu2004"
  
    config.vm.define "kasm" do |t|
      t.vm.box = IMAGEN
      t.vm.hostname = "kasm"
      t.vm.network "public_network", bridge: "Intel(R) Wi-Fi 6 AX201 160MHz", ip: "192.168.0.112"
      t.vm.network "forwarded_port", guest: 443, host: 8443
    
      t.vm.provision "shell", inline: <<-SHELL 
        # export KASM="https://kasm-static-content.s3.amazonaws.com/kasm_release_1.10.0.238225.tar.gz"
        
        export GZ="kasm.tar.gz"
        export TAR="kasm.tar"
        
        if grep -Fxq "/mnt/4GiB.swap swap swap defaults 0 0" /etc/fstab
        then
            echo "fstab entry present"
        else
            sudo fallocate -l 4g /mnt/4GiB.swap
            sudo chmod 600 /mnt/4GiB.swap
            sudo mkswap /mnt/4GiB.swap
            sudo swapon /mnt/4GiB.swap
            echo '/mnt/4GiB.swap swap swap defaults 0 0' | sudo tee -a /etc/fstab
        fi
        
        if [ -f "/tmp/kasm.tar.gz" ]; then
            echo "/tmp/kasm.tar.gz exists."
        else 
            cp /vagrant/images/kasm.tar.gz /tmp/
        fi

        if [ -f "/tmp/kasm.tar" ]; then
            echo "/tmp/kasm.tar exists."
        else
            gunzip /tmp/kasm.tar.gz
        fi

        if [ -d "$HOME/kasm_release/" ]; then
            echo "$HOME/kasm_release/ exists."
        else
            tar -xvf /tmp/kasm.tar
        fi

        sudo apt-get update -y
        sudo apt-get install net-tools -y
        sudo apt-get install ca-certificates curl gnupg lsb-release -y
        curl -fsSL https://download.docker.com/linux/ubuntu/gpg | sudo gpg --dearmor -o /usr/share/keyrings/docker-archive-keyring.gpg
        echo "deb [arch=$(dpkg --print-architecture) signed-by=/usr/share/keyrings/docker-archive-keyring.gpg] https://download.docker.com/linux/ubuntu $(lsb_release -cs) stable" | sudo tee /etc/apt/sources.list.d/docker.list > /dev/null
        sudo apt-get update -y
        sudo apt-get install docker-ce docker-ce-cli containerd.io -y

        # process_443=$( sudo netstat -ltnp | grep -w ':443' | awk '{print $7}' | cut -d '/' -f2 )
        # if [ "$process_443" != "docker-proxy" ]; then
        #     sudo netstat -ltnp | grep -w ':443' | awk '{print $7}' | cut -d '/' -f1 | xargs sudo kill -9
        #     wget -q --spider http://google.com
        #     if [ $? -eq 0 ]; then
                echo "y" | sudo bash /home/vagrant/kasm_release/install.sh >> /vagrant/kasm.log
        #     else
        #         echo "y" | sudo bash /home/vagrant/kasm_release/install.sh -w /vagrant/images/workspace_images.tar.gz -s /vagrant/images/service_images.tar.gz >> /vagrant/kasm.log
        #     fi
        # else
        #     echo "443 is already running."
        # fi
      SHELL

    end
  
    config.vm.provider "virtualbox" do |vb|
      vb.name = "kasm"
      vb.memory = "4096"
      vb.cpus = "2"
    end  
  end
  
  